<template>
  <main>
    <form @submit.prevent="handleSubmit">
      <fieldset>
        <label for="api-token-field">API token</label>
        <input id="api-token-field" v-model="form.apiToken.value" type="password" />
        <p>
          A personal access token. It should have the api scope and belong to a user that has
          access to the project in which the issues will be created.
        </p>
      </fieldset>
      <fieldset>
        <label for="api-url-field">GitLab instance URL</label>
        <input id="api-url-field" v-model="form.apiUrl.value" />
      </fieldset>
      <fieldset>
        <label for="project-id-field">Project path</label>
        <input id="project-id-field" v-model="form.projectPath.value" />
        <p>
          Path of the project in which to create the issues.
        </p>
      </fieldset>
      <fieldset>
        <label for="epic-field">Epic</label>
        <input id="epic-field" v-model="form.epic.value" @change="fetchEpic" />
        <p>
          An optional epic to which the issues should be linked. Can be a full
          URL to the epic, like
          <code>https://gitlab.com/groups/group1/subgroup/-/epics/123</code> or
          a shorthand reference, like <code>group1/subgroup&amp;123</code>.
        </p>
        <p v-if="isLoadingEpic">Loading epic...</p>
        <p v-else-if="epicTitle">
          Found epic: <q>{{ epicTitle }}</q>
        </p>
        <p v-else>No epic found or specified.</p>
      </fieldset>
      <fieldset>
        <label for="item-list-field">
          List of items to iterate through (one per line)
        </label>
        <textarea id="item-list-field" v-model="form.itemsRaw.value" rows="10" />
        <p>
          An issue will be created for each item in this list. You can reference the item in the
          issues' title and description with the <b>{{ $options.ITEM_TOKEN }}</b> token.
        </p>
      </fieldset>
      <fieldset>
        <label for="title-pattern-field">
          Title pattern
        </label>
        <input id="title-pattern-field" v-model="form.titlePattern.value" />
      </fieldset>
      <fieldset>
        <label for="description-pattern-field">
          Description pattern
        </label>
        <textarea
          id="description-pattern-field"
          v-model="form.descriptionPattern.value"
          rows="5"
        />
      </fieldset>
      <fieldset>
        <label for="labels-field">Labels (comma-separated)</label>
        <input id="labels-field" v-model="form.labelsRaw.value" />
      </fieldset>
      <fieldset>
        <input type="submit" :disabled="isLoadingEpic" />
      </fieldset>
    </form>
    <div>
      <pre>
        <template v-for="(log, index) in logs">
          <div
            :key="index"
            :class="['log', log.type]"
          >
          <template v-if="log.details">
            <details>
              <summary>
                {{ log.summary }}
                <a v-if="log.url" target="_blank" :href="log.url">
                  {{ log.url }}
                </a>
              </summary>
              {{ log.details }}
            </details>
          </template><span v-else>
            {{ log.summary }}
            <a v-if="log.url" target="_blank" :href="log.url">{{ log.url }}</a>
          </span>
          </div>
        </template>
      </pre>
    </div>
  </main>
</template>

<script>
import getEpicIDQuery from './graphql/get_epic_id.query.graphql';
import createIssueMutation from './graphql/create_issue.mutation.graphql';

const ITEM_TOKEN = '__ITEM__';
const ITEM_TOKEN_REPLACER = new RegExp(ITEM_TOKEN, 'g');
const LOG_TYPE = {
  INFO: 'info',
  SUCCESS: 'success',
  ERROR: 'error',
};

const initField = (key, {
  persist = true,
  defaultValue = '',
} = {}) => ({
  persist,
  value: (persist && window.localStorage.getItem(key)) || defaultValue,
});

export default {
  name: 'App',
  ITEM_TOKEN,
  data() {
    return {
      logs: [],
      form: {
        apiToken: initField('apiToken', { persist: false, defaultValue: '' }),
        apiUrl: initField('apiUrl', { defaultValue: 'https://gitlab.com/' }),
        projectPath: initField('projectPath'),
        epic: initField('epic'),
        itemsRaw: initField('itemsRaw'),
        labelsRaw: initField('labelsRaw'),
        titlePattern: initField('titlePattern', { defaultValue: ITEM_TOKEN }),
        descriptionPattern: initField('descriptionPattern', { defaultValue: ITEM_TOKEN }),
      },
      epic: null,
      isLoadingEpic: false,
    };
  },
  computed: {
    apolloContext() {
      return {
        uri: `${this.form.apiUrl.value.replace(/\/+$/, "")}/api/graphql`,
        headers: { Authorization: `Bearer ${this.form.apiToken.value}` }
      };
    },
    items() {
      return this.form.itemsRaw.value.split('\n').filter((value) => !!value);
    },
    labels() {
      return this.form.labelsRaw.value
        .split(',')
        .filter((value) => !!value)
        .map((value) => value.trim());
    },
    epicTitle() {
      return this.epic?.title;
    }
  },
  mounted() {
    this.fetchEpic();
  },
  watch: {
    form: {
      deep: true,
      handler() {
        Object.entries(this.form).forEach(([key, field]) => {
          if (field.persist) {
            window.localStorage.setItem(key, field.value);
          }
        });
      },
    },
  },
  methods: {
    addLogEntry(summary, { url = '', details = '', type = LOG_TYPE.INFO } = {}) {
      this.logs.push({
        summary, url, details, type,
      });
    },
    getEpicVariables() {
      const apiUrlValue = this.form.apiUrl.value.replace(/\/+$/, "");
      const epicValue = this.form.epic.value;

      const rEpicUrl = new RegExp(
        `^${apiUrlValue}/groups/(?<groupPath>\\w.*)/-/epics/(?<epicIid>\\d+)/?$`
      );

      const urlMatch = rEpicUrl.exec(epicValue);
      if (urlMatch?.groups) {
        return { ...urlMatch.groups };
      }

      const [groupPath, epicIid] = epicValue.split("&");
      if (groupPath && epicIid) {
        return { groupPath, epicIid };
      }
    },
    async fetchEpic() {
      const epicVariables = this.getEpicVariables();

      if (!epicVariables) {
        this.epic = null;
        return;
      }

      try {
        this.isLoadingEpic = true;
        const response = await this.$apollo.query({
          query: getEpicIDQuery,
          context: this.apolloContext,
          variables: epicVariables
        });

        this.epic = response.data.group?.epic;
      } catch (e) {
        this.epic = null;
        console.error("Failed to get epic details", e);
      } finally {
        this.isLoadingEpic = false;
      }
    },
    async handleSubmit() {
      if (this.isLoadingEpic) return;

      this.logs = [];
      const { items } = this;
      const markStart = performance.now();

      this.addLogEntry(`Started processing ${items.length} items.`);

      await Promise.all(
        items.map((item) => {
          const title = this.form.titlePattern.value.replace(ITEM_TOKEN_REPLACER, item);
          const description = this.form.descriptionPattern.value.replace(
            ITEM_TOKEN_REPLACER,
            item,
          );
          const { projectPath } = this.form;
          const epicId = this.epic?.id;
          const { labels } = this;
          console.log("epicId", epicId);
          return this.$apollo
            .mutate({
              mutation: createIssueMutation,
              variables: {
                projectPath: projectPath.value,
                epicId,
                title,
                description,
                labels,
              },
              context: this.apolloContext,
            })
            .then(
              ({
                data: {
                  createIssue: {
                    issue: { webUrl },
                  },
                },
              }) => {
                this.addLogEntry(
                  `Created issue "${title}".`,
                  { url: webUrl, details: description, type: LOG_TYPE.SUCCESS },
                );
              },
            )
            .catch((e) => {
              this.addLogEntry(`Could not create issue "${title}".`, {
                details: e.toString(),
                type: LOG_TYPE.ERROR,
              });
            });
        }),
      );
      const markEnd = performance.now();
      this.addLogEntry(
        `Finished processing ${items.length} items. Took ${Math.round(
          markEnd - markStart,
        )}ms.`,
      );
    },
  },
};
</script>

<style>
html,
body {
  margin: 0;
  padding: 0;
}

main {
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(320px, 1fr));
  grid-gap: 1rem;
  height: 100vh;
  align-items: center;
}

main > * {
  height: 100vh;
}

form {
  display: flex;
  flex-direction: column;
}

fieldset {
  display: flex;
  flex-direction: column;
  border: none;
}

fieldset > p {
  margin: 5px 0 0;
  color: grey;
}

pre {
  height: 100%;
  overflow: auto;
  padding: 0;
  margin: 0;
  background: black;
  color: white;
  white-space: normal;
}

.log {
  margin: 1rem;
}

.log,
.log a {
  color: white;
}

.log.success,
.log.success a {
  color: greenyellow;
}

.log.error,
.log.error a {
  color: red;
}
</style>
